#ifndef ZBCRH
#define ZBCRH

#define LIB_MAJOR         1
#define LIB_MINOR         3
#define LIB_MICRO         29
#define LIB_PATCH         2

#ifdef WIN32
#define ZBCR_CALL  __stdcall
#define ZBCR_EXP   
#else
#define ZBCR_CALL   
#define ZBCR_EXP __attribute__ ((visibility("default")))
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef int  ZBCR_STATUS ;


/*
    ɹص
*/
typedef void (ZBCR_CALL *CALL_BACK_DATA)(unsigned char *data,unsigned int length, unsigned long userdata);

#define EVENT_DOWNLOAD_PRECENT      0x1001
/*
    ӿ¼ص
*/
typedef void (ZBCR_CALL *CALL_BACK_EVENT)(unsigned int event, unsigned long data, unsigned long userdata);

/*
    ˿ڲ
*/
typedef struct portParam
{
    short portNo;
    unsigned long baudRate;
}PortParam;


/*
    ɨ豸

    @param
        pParam  ָ˿PortParamݵָ. 
                NULL Զɨ豸
                Ϊ portNo
                    0 - 1000 ں 
                    1100     HID˿
                    -1       Զɨ豸
                    -2       ԶӴ,ѯд
    @return  
            ZBCR_SUCCESS    򿪳ɹ
            ZBCR_INIT_FAIL  ʧ
*/
ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_Open(void* pParam, CALL_BACK_DATA pfnReadData, unsigned long userdata);

/*
    ɨ豸

    @param
        portNo  
                0 - 1000 ں 
                1100     HID˿
                -1       Զɨ豸
                -2       ԶӴ,ѯд
        baudRate
                ڲ
        pfnReadData
                صָ
        userdata
                ûݾȣص
    @return  
            ZBCR_SUCCESS    򿪳ɹ
            ZBCR_INIT_FAIL  ʧ
*/
ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_Open2(short portNo, long baudRate, CALL_BACK_DATA pfnReadData, unsigned long userdata);

/*
    ɨ豸 linuxϵͳ豸ڵַ

    @param
        portAddr      
                ˿ڵַ
        baudRate
                ڲ
        pfnReadData
                صָ
        userdata
                ûݾȣص
    @return  
            ZBCR_SUCCESS    򿪳ɹ
            ZBCR_INIT_FAIL  ʧ
*/
ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_Open4(const char* portAddr, long baudRate,CALL_BACK_DATA pfnReadData, unsigned long userdata);

/*
    ر豸ӣͷԴ
    @param
    @return     1       
*/
ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_Close(void);


/*
    ɨ豸ɨ빤ģʽ
    @param
        mode  ģʽ
    @return  
            1    ɹ
            <0   ʧ
*/
typedef enum {
    LEVEL=0,            //¿ʼ룬ɿɹֹͣ
    TOGGLE=1,           //¿ʼ룬ٴΰֹͣ
    AUTO=2,             //ϵһֱ
    PULSE=4,            //룬¿ʼ룬ֱﵽʱʱɹֹͣ
    MOTION_SENSOR=5     //ɨװù̶ͼƶӦ
} SCAN_MODE;
ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_ScanMode(unsigned int mode);
/*
    ɨ룬Ҫ ģʽ SCAN_MODE_LEVEL
    @param
        
    @return  
            1    ɹ
            0   ʧ
*/
ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_StartScan(void);
/*
    ֹͣɨ
    @param
        
    @return  
            1    ɹ
            0   ʧ
*/
ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_StopScan(void);
/*
    ȡ
    @param
        nTimeOut            ȴȡʱʱ(λ 100ms)
        pOutputBuffer       ȡĽݻ
        nSizeOfOutputBuffer ռС
        pnBytesReturned     ʵʽݳ
    @return  
            1    ɹ
            0    
*/
// totalTimeOunt = nTimeOut*100ms
ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_ReadDecode(unsigned short nTimeOut,
							unsigned char* pOutputBuffer, 
                            unsigned int nSizeOfOutputBuffer,
                            unsigned int *pnBytesReturned);



ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_SetupRead(unsigned char* pInputBuffer,
									    unsigned int nBytesInInputBuffer,
									    unsigned char *pOutputBuffer, 
								        unsigned int nSizeOfOutputBuffer, 
								        unsigned int *pnBytesReturned);


ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_SetupWrite(unsigned char* pInputBuffer,
									     unsigned int nBytesInInputBuffer,
									     unsigned char *pOutputBuffer, 
									     unsigned int nSizeOfOutputBuffer, 
                                         unsigned int *pnBytesReturned);


ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_ControlCmd (unsigned char *pInputBuffer,
									  unsigned int nBytesInInputBuffer,
									  unsigned char *pOutputBuffer,
									  unsigned int nSizeOfOutputBuffer,
                                      unsigned int *pnBytesReturned);


ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_StatusRead(  unsigned char* pInputBuffer,
									   unsigned int nBytesInInputBuffer,
									   unsigned char *pOutputBuffer, 
									   unsigned int nSizeOfOutputBuffer, 
									   unsigned int *pnBytesReturned);

ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_Command(unsigned char* pInputBuffer,
                                               unsigned int nBytesInInputBuffer,
                                               unsigned char *pOutputBuffer, 
                                               unsigned int nSizeOfOutputBuffer, 
                                               unsigned int *pnBytesReturned);
/*
  ȡһͼݴСڷ洢ͼݿռ

  @param
  @return  
            > 0 ͼݴС
            -1  ȡʧ
*/
ZBCR_EXP int  ZBCR_CALL ZBCR_GetLastImageSize(void);

/*
  ȡһͼ

  @param
            image_data  ͼݻָ룬ָ򻺴ռ䣬Ϊ
            imagesize   [] ռС [] ʵʻȡݴСΪ
            image_w     ͼ
            image_h     ͼ߶
  @return  
            ZBCR_SUCCESS    ȡɹ
            ֵ      ȡʧ
*/
ZBCR_EXP ZBCR_STATUS  ZBCR_CALL ZBCR_GetLastImage(unsigned char* image_data, int* imagesize, int* image_w, int* image_h);



/*
    ȡAPI汾
    @param
        ver_str  汾ַ
    @return  
            ZBCR_SUCCESS
            ZBCR_PARAM_POINT_NULL
*/
ZBCR_EXP ZBCR_STATUS ZBCR_CALL ZBCR_GetApiVersion(char* ver_str);
#ifdef __cplusplus
}
#endif

#endif
